local mapInfo = {
  author = "Team 1",
  description = "",
  modtype = 3,
  name = "qertwet",
  shortname = "",
  version = "1",
  voidGround = false,
  voidWater = false,
  atmosphere = {
    fogEnd = 1,
    fogStart = 0.1,
    skyBox = "",
    cloudColor = {
      1,
      1,
      1,
    },
    fogColor = {
      0.69999999,
      0.69999999,
      0.80000001,
    },
    skyColor = {
      0.1,
      0.15000001,
      0.69999999,
    },
    sunColor = {
      1,
      1,
      1,
    },
  },
  custom = {},
  depend = {
    "Map Helper v1",
  },
  grass = {},
  lighting = {
    groundShadowDensity = 0.80000001,
    unitShadowDensity = 0.80000001,
    groundAmbientColor = {
      0.5,
      0.5,
      0.5,
    },
    groundDiffuseColor = {
      0.5,
      0.5,
      0.5,
    },
    groundSpecularColor = {
      0.1,
      0.1,
      0.1,
    },
    sunDir = {
      0,
      0.44721356,
      0.89442712,
    },
    unitAmbientColor = {
      0.40000001,
      0.40000001,
      0.40000001,
    },
    unitDiffuseColor = {
      0.69999999,
      0.69999999,
      0.69999999,
    },
    unitSpecularColor = {
      0.69999999,
      0.69999999,
      0.69999999,
    },
  },
  replace = {},
  resources = {
    detailTex = "maps/detail.png",
    splatDetailNormalDiffuseAlpha = false,
  },
  smf = {
    grassmapTex = "maps/grass.png",
    maxheight = 261.445953,
    minheight = -81.599983,
    smtFileName0 = "maps/qertwet.smt",
  },
  teams = {
    [0] = {
      startPos = {
        x = 2560,
        z = 3072,
      },
    },
    [1] = {
      startPos = {
        x = 3546.59717,
        z = 5280.82227,
      },
    },
    [2] = {
      startPos = {
        x = 3492.72021,
        z = 633.601807,
      },
    },
  },
  terrainTypes = {},
  water = {
    ambientFactor = 1,
    blurBase = 2,
    blurExponent = 1.5,
    diffuseFactor = 1,
    foamTexture = "bitmaps/foam.jpg",
    forceRendering = false,
    fresnelMax = 0.80000001,
    fresnelMin = 0.2,
    fresnelPower = 4,
    hasWaterPlane = true,
    normalTexture = "bitmaps/waterbump.png",
    numTiles = 3,
    perlinAmplitude = 0.89999998,
    perlinLacunarity = 3,
    perlinStartFreq = 8,
    reflectionDistortion = 1,
    repeatX = 0,
    repeatY = 0,
    shoreWaves = true,
    specularFactor = 1,
    specularPower = 20,
    texture = "bitmaps/ocean.jpg",
    diffuseColor = {
      1,
      1,
      1,
    },
    planeColor = {
      0,
      0.40000001,
      0,
    },
    specularColor = {
      0.5,
      0.5,
      0.5,
    },
  },
}
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Helper

local function lowerkeys(ta)
    local fix = {}
    for i,v in pairs(ta) do
        if (type(i) == "string") then
            if (i ~= i:lower()) then
                fix[#fix+1] = i
            end
        end
        if (type(v) == "table") then
            lowerkeys(v)
        end
    end

    for i=1,#fix do
        local idx = fix[i]
        ta[idx:lower()] = ta[idx]
        ta[idx] = nil
    end
end

lowerkeys(mapInfo)

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- Map Options

if (Spring) then
    local function tmerge(t1, t2)
        for i,v in pairs(t2) do
            if (type(v) == "table") then
                t1[i] = t1[i] or {}
                tmerge(t1[i], v)
            else
                t1[i] = v
            end
        end
    end

    -- make code safe in unitsync
    if (not Spring.GetMapOptions) then
        Spring.GetMapOptions = function() return {} end
    end
    function tobool(val)
        local t = type(val)
        if (t == 'nil') then
            return false
        elseif (t == 'boolean') then
            return val
        elseif (t == 'number') then
            return (val ~= 0)
        elseif (t == 'string') then
            return ((val ~= '0') and (val ~= 'false'))
        end
        return false
    end

    getfenv()["mapInfo"] = mapInfo
        local files = VFS.DirList("mapconfig/mapinfo/", "*.lua")
        table.sort(files)
        for i=1,#files do
            local newcfg = VFS.Include(files[i])
            if newcfg then
                lowerkeys(newcfg)
                tmerge(mapInfo, newcfg)
            end
        end
    getfenv()["mapInfo"] = nil
end

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

return mapInfo
